/*
 * CELImageFrame.java
 *
 * Created on May 17, 2006, 12:18 AM
 */

package MBR;
import java.awt.image.MemoryImageSource;
import java.awt.Image;
import java.util.Vector;
import java.awt.color.ColorSpace;
import java.awt.image.DirectColorModel;
import java.awt.image.ComponentColorModel;
import java.lang.Math;
/**
 *
 * @author  jssong
 */
public class CELImageFrame extends javax.swing.JFrame {
    
    int width, height;
    float[][] pix;
    float[][][] intensities;
    int [][] quantiles;
    int nImages;
    int currentImageNumber = 0 ;
    double refinementThreshold = 0.9;
    String[] imageNames;
    String path;   // path of CELL files
    Vector outlierList  = null;
    Vector emptylist = new Vector();
    int quantCutoff;
    /** Creates new form CELImageFrame */

    public CELImageFrame(int width, int height, float[][][] pixels) {
        this.width = width;
        this.height = height;
        this.pix = pixels[0];
        this.intensities = pixels;
        this.nImages = pixels.length;
        initComponents();
        java.awt.Dimension dim = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        this.setSize(dim.width-50, dim.height-50);
        pixelImagePane2.init();
        pixelImagePane2.setDim();
        pixelImagePane2.setPixels(pixels[0], width, height);
        
        pixelImagePane2.init();
        pixelImagePane2.repaint();
       
        pixelImagePane2.setVisible(true);
        jDialog1.setSize(new java.awt.Dimension(370,320));
    }
    
    public CELImageFrame(int width, int height, String path, String[] names, float[][][] pixels, int[][] quantiles) {
        this.width = width;
        this.height = height;
        this.pix = pixels[0];
        this.intensities = pixels;
        this.nImages = pixels.length;
        this.quantiles = quantiles;
        this.imageNames = names;
        this.path = path;
        
        initComponents();
        java.awt.Dimension dim = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        this.setSize(dim.width-100, dim.height-100);
        pixelImagePane2.setQuantiles(quantiles[0]);
        pixelImagePane2.init();
        pixelImagePane2.setDim();
        pixelImagePane2.setPixels(pixels[0], width, height);
        
        pixelImagePane2.init();
        pixelImagePane2.repaint();
       
        pixelImagePane2.setVisible(true);
        this.setTitle(imageNames[0]);
        jDialog1.setSize(new java.awt.Dimension(400,500));
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jDialog1 = new javax.swing.JDialog();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        pixelImagePane2 = new PixelImagePane(width,height,pix);
        jPanel1 = new javax.swing.JPanel();
        jSlider1 = new javax.swing.JSlider();
        jSlider2 = new javax.swing.JSlider();
        jSlider3 = new javax.swing.JSlider();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        exitButton = new javax.swing.JButton();
        saveButton = new javax.swing.JButton();
        findBubbleButton = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        jSlider4 = new javax.swing.JSlider();
        jSlider5 = new javax.swing.JSlider();
        jButton1 = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        jTextPane1.setEditable(false);
        jTextPane1.setFont(new java.awt.Font("Tahoma", 1, 11));
        jTextPane1.setText("BUTTONS\n\n* Find Blobs: Detects blobs using the selected parameter values.\n\n* Save: Writes a new CEL file with the coordinates of all detected blobs in \"Outlier Entries.\"\n\n* Original Histograms: Displays the histograms of probe intensities from the original CEL file.\n\n   On the histogram panel,\n       - Left-click and drag to zoom in.\n       - Right-click to get options.\n\n* MBR Histograms: Displays the histograms of probe intensities, with MBR detected blobs as outliers.\n\n* Remove Outliers: Writes a new CEL file with an empty \"Outlier Entries\" section.\n\n\n\n\nSLIDERS\n\n* Window Level: Adjusts the intensity interval to be displayed.\n\n* Images: Scrolls through multiple images.\n\n* Threshold for Blob Detection: Quantile cutoff for the first scan.  At least half of the pixels in a 100x100 sliding square must have intensity higher than this cutoff in order for the square to be considered as a candidate blob.  If the program doesn't detect what you suspect to be a blob, then try lowering this threshold.\n\n* Refinement Threshold:  The candidate square regions are rescanned with small circles; and the percentage of high intensity pixels in a circle must be greater than this threshold in order for the circle to pass as a blob.\n");
        jScrollPane2.setViewportView(jTextPane1);

        org.jdesktop.layout.GroupLayout jDialog1Layout = new org.jdesktop.layout.GroupLayout(jDialog1.getContentPane());
        jDialog1.getContentPane().setLayout(jDialog1Layout);
        jDialog1Layout.setHorizontalGroup(
            jDialog1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 437, Short.MAX_VALUE)
        );
        jDialog1Layout.setVerticalGroup(
            jDialog1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jScrollPane1.setAutoscrolls(true);
        pixelImagePane2.setAutoscrolls(true);
        pixelImagePane2.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                pixelImagePane2MouseMoved(evt);
            }
        });

        org.jdesktop.layout.GroupLayout pixelImagePane2Layout = new org.jdesktop.layout.GroupLayout(pixelImagePane2);
        pixelImagePane2.setLayout(pixelImagePane2Layout);
        pixelImagePane2Layout.setHorizontalGroup(
            pixelImagePane2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 1013, Short.MAX_VALUE)
        );
        pixelImagePane2Layout.setVerticalGroup(
            pixelImagePane2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 584, Short.MAX_VALUE)
        );
        jScrollPane1.setViewportView(pixelImagePane2);

        jSlider1.setMajorTickSpacing(10);
        jSlider1.setMinorTickSpacing(5);
        jSlider1.setPaintLabels(true);
        jSlider1.setPaintTicks(true);
        jSlider1.setValue(90);
        jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider1StateChanged(evt);
            }
        });

        jSlider2.setMajorTickSpacing(10);
        jSlider2.setMinorTickSpacing(5);
        jSlider2.setPaintLabels(true);
        jSlider2.setPaintTicks(true);
        jSlider2.setValue(10);
        jSlider2.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider2StateChanged(evt);
            }
        });

        jSlider3.setMajorTickSpacing(1);
        jSlider3.setMaximum(nImages);
        jSlider3.setMinimum(1);
        jSlider3.setPaintLabels(true);
        jSlider3.setSnapToTicks(true);
        jSlider3.setValue(1);
        jSlider3.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider3StateChanged(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setLabelFor(jSlider1);
        jLabel1.setText("Window Level");
        jLabel1.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jLabel2.setText("Min");

        jLabel3.setText("Max");

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setLabelFor(jSlider3);
        jLabel4.setText("Images");

        exitButton.setText("Close");
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });

        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        findBubbleButton.setText("Find Blobs");
        findBubbleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                findBubbleButtonActionPerformed(evt);
            }
        });

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel5.setLabelFor(jSlider4);
        jLabel5.setText("Threshold for Blob Detection");

        jSlider4.setMajorTickSpacing(10);
        jSlider4.setMinimum(60);
        jSlider4.setMinorTickSpacing(5);
        jSlider4.setPaintLabels(true);
        jSlider4.setPaintTicks(true);
        jSlider4.setValue(90);
        jSlider4.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider4StateChanged(evt);
            }
        });

        jSlider5.setMajorTickSpacing(5);
        jSlider5.setMinimum(80);
        jSlider5.setPaintLabels(true);
        jSlider5.setPaintTicks(true);
        jSlider5.setValue(90);
        jSlider5.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider5StateChanged(evt);
            }
        });

        jButton1.setText("Remove Outliers");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel6.setText("Refinement Threshold");

        jButton2.setText("Help");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Original Histogram");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("MBR Histogram");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jSlider2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jSlider1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel2)
                                    .add(jLabel3))
                                .add(57, 57, 57)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jSlider4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jSlider3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(117, 117, 117)
                                .add(jLabel5)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(21, 21, 21)
                                .add(jSlider5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(57, 57, 57)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(findBubbleButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 119, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 129, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                        .add(54, 54, 54)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(saveButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(exitButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(jButton1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jButton3)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .add(jButton2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(165, 165, 165)
                        .add(jLabel4)))
                .add(31, 31, 31))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                        .add(29, 29, 29)
                        .add(saveButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 86, Short.MAX_VALUE)
                        .add(jLabel3)
                        .add(32, 32, 32))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(15, 15, 15)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel4))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel2)
                            .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                .add(jSlider2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(jSlider3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(jButton3)
                                .add(jButton4))
                            .add(findBubbleButton))
                        .add(7, 7, 7)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel5)
                            .add(jLabel6)
                            .add(jButton1))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 18, Short.MAX_VALUE)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton2)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(exitButton))
                            .add(jSlider5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                .add(jSlider4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(jSlider1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                .add(23, 23, 23))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 1017, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 588, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        String outpath = path + java.io.File.separator + imageNames[currentImageNumber];
       
        if (outlierList != null){
            CELParser cel = new CELParser(outpath,0);
            int k = outlierList.size();
            System.out.println("outliers = " + k);

            short[][] outloc = new short[k][2];
            for (int i = 0; i < k ; i ++){
                short[] tmp = (short[]) outlierList.elementAt(i);
                outloc[i] = tmp;
            }
            cel.getHistogram(outloc, "MBR "+imageNames[currentImageNumber]);
        }
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        String outpath = path + java.io.File.separator + imageNames[currentImageNumber];
        CELParser cel = new CELParser(outpath,0);
        cel.getHistogram(cel.readOutliers(), imageNames[currentImageNumber]);
        
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    jDialog1.show(true);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        
        String outpath = path + java.io.File.separator + imageNames[currentImageNumber];
        CELParser out = new CELParser(outpath,1);
        System.out.println(outpath);
        String fo = out.writeNewCEL(emptylist);
        this.setTitle("New CEL file: " +fo);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jSlider5StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider5StateChanged
// TODO add your handling code here:
        javax.swing.JSlider source = (javax.swing.JSlider)evt.getSource();
        if (!source.getValueIsAdjusting()) {
             refinementThreshold = (double) source.getValue()*0.01;
             
        }
    }//GEN-LAST:event_jSlider5StateChanged

    /* Compute average intensity in a box of specified length */
    private int countHotSpots(int xmin, int ymin, int length, int area, int cutoff){
        int xmax = Math.min(width-1,xmin + length);
        int ymax = Math.min(height-1,ymin + length);
        int sum = 0;
        for (int i = xmin; i < xmax; i ++){
            for( int j = ymin ; j < ymax ; j++){
                if (intensities[currentImageNumber][i][j] > cutoff) sum += 1;
            }
        }
        return sum;
    }
    
    private float aveInACircle(int xCenter, int yCenter, int radius, int cutoff){
        int area=0; int count=0;
        int xMax = Math.min(width-1, xCenter + radius);
        int yMax = Math.min(height-1, yCenter + radius);
        int yMin = Math.max(0, yCenter - radius);
        
        int xdist = 0;
        int R = radius * radius;
        for (int i = Math.max(0, xCenter - radius); i <= xMax; i++){
            xdist = (i-xCenter)*(i-xCenter);
            for (int j = yMin; j <= yMax; j++){
                if ( xdist + (j-yCenter)*(j-yCenter) <= R){
                    area ++;
                    if (intensities[currentImageNumber][i][j]>= cutoff){
                        count ++;
                    }
                }
            }
        }
        return ((1.0f*count)/area);
    }
    private void paintCircle(int xCenter, int yCenter, int radius, int[][] array, boolean[][] bubble2){
        int average=0; int count=0;
        int xMax = Math.min(width-1, xCenter + radius);
        int yMax = Math.min(height-1, yCenter + radius);
        int yMin = Math.max(0, yCenter - radius);
       
        int xdist = 0;
        int R = radius * radius;
        for (int i = Math.max(0, xCenter - radius); i <= xMax; i++){
            xdist = (i-xCenter)*(i-xCenter);
            for (int j = yMin; j <= yMax; j++){
                
                if (xdist + (j-yCenter)*(j-yCenter) <= R){
                    bubble2[i][j] = true;
                    array[i/2][j/2] = 0xff0000;
                }
            }
        }
       
    }
    private void jSlider4StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider4StateChanged
        javax.swing.JSlider source = (javax.swing.JSlider)evt.getSource();
        if (!source.getValueIsAdjusting()) {
            quantCutoff = (int)source.getValue();
        }
    }//GEN-LAST:event_jSlider4StateChanged
    private void updateOutlierList(Vector v, boolean[][] bubble){
        
        for ( int j =0; j < height; j ++){
            for (int i = 0; i < width; i ++){
                if (bubble[i][j]) v.add(new short[]{(short) i,(short) j });
            }
        }
    }
    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        String outpath = path + java.io.File.separator + imageNames[currentImageNumber];
        CELParser out = new CELParser(outpath,1);
        System.out.println(outpath);
        String fo = out.writeNewCEL(outlierList);
        this.setTitle("New CEL file: " +fo);
    }//GEN-LAST:event_saveButtonActionPerformed

    /* find candidate bubbles */
    private void findBubbleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_findBubbleButtonActionPerformed
        
        this.setTitle("Processing Image... Please wait....");
        int high = jSlider1.getValue();
        int low = jSlider2.getValue();
        quantCutoff = jSlider4.getValue();
        pixelImagePane2.adjustWindow(low,high,pix);

        outlierList = new Vector();

        
        int cutoff = quantiles[currentImageNumber][quantCutoff];
        int lowerCutoff = quantiles[currentImageNumber][quantCutoff-5];
        int length = 100;
        int area = 10000;
        int xMax = width -1 ; 
        int yMax = height -1; 
        int ave;
        int[][] bubble = new int[width/2][height/2];
        boolean[][] bubble2 = new boolean[width][height];  // to update outlierList
        for (int i = 0; i < xMax; i += 50){
            for (int j = 0; j < yMax; j+= 50){
                ave = countHotSpots(i,j,length,area, cutoff);
                if ( ave >  5000 ){
                    int refineLength = 6;
                    int xMax2 = Math.min(xMax, i + length);
                    int yMax2 = Math.min(yMax, j + length);

                    for (int i2 = Math.max(0, i) ; i2 < xMax2 ; i2 += 2){
                        for (int j2 = Math.max(0,j); j2 < yMax2; j2 +=2){
                            if(aveInACircle(i2,j2, 20, lowerCutoff) >  refinementThreshold){
                                paintCircle(i2,j2,20,bubble, bubble2);
                            }
                        }
                    }
                }
            }
        }
        pixelImagePane2.addBubble(bubble);
        updateOutlierList(outlierList, bubble2);
        this.setTitle("Done.  Please verify the image.");
    }//GEN-LAST:event_findBubbleButtonActionPerformed

    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
        this.show(false);
    }//GEN-LAST:event_exitButtonActionPerformed

    private void jSlider3StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider3StateChanged
        javax.swing.JSlider source = (javax.swing.JSlider)evt.getSource();
        if (!source.getValueIsAdjusting()) {
            int imageNumber = (int)source.getValue()-1;
             
             if (imageNumber >= nImages || imageNumber == currentImageNumber) return; 
             pix = intensities[imageNumber];
             jSlider1.setValue(90);
             jSlider2.setValue(10);
             pixelImagePane2.setQuantiles(quantiles[imageNumber]);
             pixelImagePane2.setPixels(pix, width, height);
             width = pix.length;
             height = pix[0].length;
             currentImageNumber = imageNumber;
             this.setTitle(imageNames[currentImageNumber]);
             
        }
    }//GEN-LAST:event_jSlider3StateChanged

    private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider1StateChanged
        javax.swing.JSlider source = (javax.swing.JSlider)evt.getSource();
        if (!source.getValueIsAdjusting()) {
            int high = (int)source.getValue();
            this.setTitle(high+"");
            int low = jSlider2.getValue();
            pixelImagePane2.adjustWindow(low,high,pix);
        }
    }//GEN-LAST:event_jSlider1StateChanged

    private void jSlider2StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider2StateChanged
        javax.swing.JSlider source = (javax.swing.JSlider)evt.getSource();
        if (!source.getValueIsAdjusting()) {
            int low = (int)source.getValue();
            this.setTitle(low+"");
            int high = jSlider1.getValue();
            pixelImagePane2.adjustWindow(low,high,pix);
        }
    }//GEN-LAST:event_jSlider2StateChanged

    private void pixelImagePane2MouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_pixelImagePane2MouseMoved
        int x = 2*evt.getX();
        int y = 2*evt.getY();
        if (x < width && y < height)
            this.setTitle(imageNames[currentImageNumber]+" :   (X,Y) = (" +x+","+y+")" + " ,     Intensity = " + pix[x][y] +" ,    Image Dimension = ("+width +", "+height+")");
    }//GEN-LAST:event_pixelImagePane2MouseMoved
   public static int aveInACircle(int radius){
        int area=0; int count=0;
        int xdist = 0;
        int R = radius * radius;
        for (int i = -radius; i <= radius; i++){
            xdist = (i)*(i);
            for (int j = -radius; j <= radius; j++){
                if ( xdist + (j)*(j) <= R){
                    area ++;
                }
            }
        }
        return area;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
         System.out.println(CELImageFrame.aveInACircle(20));
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton exitButton;
    private javax.swing.JButton findBubbleButton;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JDialog jDialog1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSlider jSlider1;
    private javax.swing.JSlider jSlider2;
    private javax.swing.JSlider jSlider3;
    private javax.swing.JSlider jSlider4;
    private javax.swing.JSlider jSlider5;
    private javax.swing.JTextPane jTextPane1;
    private MBR.PixelImagePane pixelImagePane2;
    private javax.swing.JButton saveButton;
    // End of variables declaration//GEN-END:variables
    
}
