package MBR;
/*
 * HistogramPlot.java
 *
 * Created on September 20, 2006, 9:03 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.io.IOException;
import java.util.Random;

import javax.swing.JPanel;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartFrame;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYBarRenderer;
import org.jfree.data.statistics.HistogramDataset;
import org.jfree.data.xy.IntervalXYDataset;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;
/**
 *
 * @author jssong
 */
public class HistogramPlot {
    
    /** Creates a new instance of HistogramPlot */
    public HistogramPlot() {
    }
        
    public static void showHistograms(double[][] list, int nBin, String header){
        showHistograms(list, nBin, header, "", null);
    }
    public static void showHistograms(double[][] list, int nBin, String header, String info){
        showHistograms(list, nBin, header, info, null);
    }
    public static void showHistograms(double[][] list, int nBin, String header, String info, String outpath){
        int nGraphs = list.length;

        // Can only display 3 graphs at once
       
        JPanel[] chartPanel = new JPanel[nGraphs];
        HistogramDataset dataset = new HistogramDataset();
        
            
            double[] minMax = getMinMax(list[0]);
            dataset.addSeries ("Outliers", list[0], nBin, minMax[0], minMax[1]);
            minMax = getMinMax(list[1]);
            dataset.addSeries ("No Outliers", list[1], nBin, minMax[0], minMax[1]);
            minMax = getMinMax(list[2]);
            dataset.addSeries ("All", list[2], nBin, minMax[0], minMax[1]);
           
            JFreeChart chart = ChartFactory.createHistogram(
                header, 
                null, 
                null, 
                dataset, 
                PlotOrientation.VERTICAL, 
                true, 
                false, 
                false
                );

            XYPlot plot = (XYPlot) chart.getPlot();
            plot.setForegroundAlpha(0.7f);
            XYBarRenderer renderer = (XYBarRenderer) plot.getRenderer();
            ChartFrame frame = new ChartFrame("Intensity Histograms", chart);
            frame.pack();
            frame.setVisible(true);
        
 
    }
    
    private static double[] getMinMax(double[] array){
        double min = Double.MAX_VALUE;
        double max = Double.MIN_VALUE;
        int nElements = array.length;
        double tmp;
        for (int k =0 ; k < nElements; k ++){
            tmp = array[k];
            if ( tmp < min ) min = tmp;
            if (tmp > max) max = tmp;
        }
        
        return new double[] {Math.max(0,min), Math.min(max,70000)};
    }
    
    public static void main (String[] argv){
        String norm = "C:\\cygwin\\home\\jssong\\Research\\FisherLab\\PairData\\MA2C_43412_normalized.txt";
        double[][] array =  new double[3][];
        array[0]= new double[]{1,1.1,2,3,4,5};
        array[1]= new double[]{2,2.1,3.3,4,5,6.0};
        array[2]= new double[]{2,2.1,3.3,4,5,6.0};
        HistogramPlot.showHistograms(array, 10000, "test");
    }
}
