/*
 * PixelImagePane.java
 *
 * Created on May 17, 2006, 12:41 AM
 */

package MBR;
import java.awt.image.MemoryImageSource;
import java.awt.Image; 
import java.awt.Graphics;
import java.awt.color.ColorSpace;
import java.awt.image.DirectColorModel;
import java.awt.image.ComponentColorModel;
/**
 *
 * @author  jssong
 */
public class PixelImagePane extends javax.swing.JPanel {
    
    int width, height;
    java.awt.image.MemoryImageSource imagesource;
    
    Image fImage;
    int fWidth = 0, fHeight = 0;
    int [] fPixels;
    int [] pixels;
    int [] quantiles;
    final static int MAXGRAY = 65535;
    int prevContrast = 50;
    /** Creates new form PixelImagePane */
    public PixelImagePane() {
        initComponents();
    }
    
    public PixelImagePane(int width, int height) {
        this.width = width/2;
        this.height = height/2;
        pixels = new int[this.width*this.height];
        //setDim(this.width, this.height);
        initComponents();
    }
    
    public PixelImagePane(int width, int height, float[][] pix) {
        this.width = width/2;
        this.height = height/2;
        pixels = new int[this.width*this.height];
        initPixels(pix, this.width, this.height);
        //setDim(this.width, this.height);
        initComponents();
        
    }

  /**
    * Create an image from a pixel array and MemoryImageSource.
    *
    * Do the image building in this method rather
    * than in a constructor so that it will know
    * the size of the panel after it has been added
    * to the applet.
   **/

    
    public void setQuantiles(int[] q){
        quantiles = q;
    }
    private void setDim(int width, int height){
        setPreferredSize(new java.awt.Dimension(width,height));
        setMaximumSize(new java.awt.Dimension(width,height) );
    }
    public void setDim(){
        setPreferredSize(new java.awt.Dimension(width,height));
        setMaximumSize(new java.awt.Dimension(width,height) );
    }
    public void initPixels(float[][] array, int w, int h){
       
        for (int j = 0; j < height; j ++){
            for (int i = 0; i < width; i++)
               
                pixels[j*width+i] = (int) ((array[2*i][2*j] + array[2*i+1][2*j+1] +array[2*i+1][2*j]+array[2*i][2*j+1])*.25);
        }
    }

    public void setPixels(float[][] array, int w, int h){
        int lower = 10;
        int upper = 90;
        float t = 1.0f*(quantiles[upper]-quantiles[lower]);
        int mean;
        for (int j = 0; j < height; j ++){
            for (int i = 0; i < width; i++){
                mean = (int) ((array[2*i][2*j] + array[2*i+1][2*j+1] +array[2*i+1][2*j]+array[2*i][2*j+1])*.25);
                if (mean > quantiles[upper]) pixels[j*width+i] = MAXGRAY;
                else pixels[j*width+i] =  java.lang.Math.max((int)(MAXGRAY*(mean-quantiles[lower])/t), 0); 
            }
        }
        imagesource.newPixels(0,0, width, height);
    }
    
    public void adjustWindow(int lower, int upper,float[][] array){
        float t = 1.0f*(quantiles[upper]-quantiles[lower]);
        int mean ;
        for (int j = 0; j < height; j ++){
            for (int i = 0; i < width; i++){
                mean = (int) ((array[2*i][2*j] + array[2*i+1][2*j+1] +array[2*i+1][2*j]+array[2*i][2*j+1])*.25);
                if (mean > quantiles[upper]) pixels[j*width+i] = MAXGRAY;
                else pixels[j*width+i] =  java.lang.Math.max((int)(MAXGRAY*(mean-quantiles[lower])/t), 0); 
            }
        }
        imagesource.newPixels(0,0, width, height);
        prevContrast = 50;
    }
    
    public void addBubble(int[][] array){
        
        for (int j = 0; j < height; j ++){
            for (int i = 0; i < width; i++){
                
                pixels[j*width+i] +=  array[i][j]; 
            }
        }
        imagesource.newPixels(0,0, width, height);
        prevContrast = 50;
    }
    public void changeContrast(int value){
        double scale = (double) java.lang.Math.exp( (float)(value- prevContrast)/100.0f);
        System.out.println(value + " " + scale);
        prevContrast = value;
        for (int j = 0; j < height; j ++){
            for (int i = 0; i < width; i++){
                
                pixels[j*width+i] = (int)(pixels[j*width+i] * scale );
            }
        }
        imagesource.newPixels(0,0, width, height);
    }
    void init () {
        
        fWidth  = width;
        fHeight = height;
        fPixels = new int [fWidth * fHeight];

        int i=0;
        int half_width = fWidth/2;

        // Build the array of pixels with the color components.
        for  (int y = 0; y < fHeight; y++) {
          for ( int x = 0; x < fWidth; x++) {
            // Start red on left and decrease to zero at center
            int red = 255 -  (512 * x)/fWidth;
            if (red < 0 ) red = 0;

            // Green peaks in center
            int green;
            if (x < half_width )
                green =  (100 * x)/fWidth;
            else
              green = 255 -  (255 *  (x - half_width))/half_width;

            // Blue starts from center and peaks at right side.
            int blue = 0;
            if (x > half_width)
                blue =  (255 *  (x - half_width))/half_width;

            int alpha = 255; // non-transparent
            fPixels[i++] =  (alpha << 24) |  (red << 16)
                            |  (green << 8 ) | blue;
          }
        }
        // Now create the image from the pixel array.
        
        
        DirectColorModel cm = new DirectColorModel(24,0xffff,0xffff,0xff0000);
        imagesource = new MemoryImageSource(width, height, cm, pixels, 0, width);
        imagesource.setAnimated(true);
        fImage = createImage ( imagesource);
           //new MemoryImageSource (fWidth, fHeight, fPixels, 0, fWidth));
  } // init

  /** Paint the image on the panel. **/
  public void paintComponent (Graphics g) {
    super.paintComponent (g);
    g.drawImage (fImage, 0, 0, this );
  }

  public static void main(String[] argv){
      int[] tmp ={5,2,34,1};
      java.util.Arrays.sort(tmp);
      System.out.println(tmp[0] + " "+ tmp[3]);
  }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        setPreferredSize(new java.awt.Dimension(200, 200));
        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 200, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 200, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
}
